package com.charego.freecellfx;

import com.charego.freecellfx.model.Game;
import com.charego.freecellfx.view.GameCanvas;
import javafx.application.Application;
import javafx.scene.Scene;
import javafx.scene.image.Image;
import javafx.scene.layout.*;
import javafx.stage.Stage;

public class FreeCellApplication extends Application {

    public static void main(String[] args) {
        launch(FreeCellApplication.class, args);
    }

    @Override
    public void start(Stage stage) throws Exception {
        AnchorPane root = new AnchorPane();
        root.setBackground(new Background(new BackgroundImage(new Image(
                "/deck/FELT.jpg"), BackgroundRepeat.NO_REPEAT,
                BackgroundRepeat.NO_REPEAT, BackgroundPosition.CENTER,
                BackgroundSize.DEFAULT)));

        GameCanvas canvas = new GameCanvas(new Game(), 731, 600);
        root.getChildren().add(canvas);
        Scene scene = new Scene(root);

        stage.setTitle("FreeCell");
        stage.getIcons().add(new Image("/icons/DIAMOND.jpg"));
        stage.setScene(scene);
        stage.setResizable(false);
        stage.show();
    }

}
